var $ = jQuery;
$(function() {

// Добавить преподавателя
function AddTeacher(ID, Name, Action){
	$r = '\
		<div class="Teacher" id="'+ ID +'">\
			<div class="Name">'+ Name +'</div>';
	if (Action == 'Unbind')
		$r += '<button class="Action_UnbindTeacher Action">Отсоединить</button><button class="Action_ChangeOwner Action">Передать дисциплину</button>';
	if (Action == 'Bind')
		$r += '<button class="Action_BindTeacher Action">Присоединить</button><button class="Action_ChangeOwner Action">Передать дисциплину</button>';
	$r += '\
		</div>';
	return $r;
}


// Поиск преподавателей
function CallSearchTeachers(){
	var Name = [];
	Name = ($('.InputTeacherName ').val()).split(' ');
	$.post(
		URLdir + 'handler/map/SearchTeachers',
		{
			'FacultyID': $('.SelectFaculty').val(),
			'DepartmentID': $('.SelectDepartment').val(),
			'Last': Name[0],
			'First': Name[1],
			'Second': Name[2],
			'DisciplineID': DisciplineID
		},
		function(data){
			var SearchResult = $.parseJSON(data);
			var SearchResultDIV = $('.SearchResult');
			var i = 0;
			if (SearchResult != null && SearchResult != undefined) {
				SearchResultDIV.html('');
				for(i in SearchResult) {
					var Name = SearchResult[i].TeacherLast + ' ' + SearchResult[i].TeacherFirst + ' ' + SearchResult[i].TeacherSecond;
					SearchResultDIV.append(AddTeacher(SearchResult[i].TeacherID, Name, 'Bind'));
				}
			}
			if (i<= 0) SearchResultDIV.html('<p class="notification">Нет результатов... Возможно, преподаватели, соответствующие критериям поиска, уже прикреплены.</p>');
		}
	);
}

// Выборка факультета
$('.SelectFaculty').change(function(){
	$.post(
		URLdir + 'handler/map/GetDepartments',
		{
			'FacultyID': $('.SelectFaculty').val()
		},
		function(Dep){
			var SelectDepartment = $('.SelectDepartment');
			var Dep = $.parseJSON(Dep);
			var i = 0;
			if (Dep != null && Dep != undefined) {
				SelectDepartment.html('<option value="0">Выберите кафедру (не обязательно)</option>');
				for (i in Dep) {
					SelectDepartment.append('<option value="'+ Dep[i].ID +'">'+ Dep[i].Name +'</option>');
				}
				if (i <= 0)
					SelectDepartment.html('<option value="0">Нет кафедр</option>');		
			}
			CallSearchTeachers();
		}
	);
});

$('.SelectDepartment ').change(function(){
	CallSearchTeachers();
});
$('.InputTeacherName').focusout(function(){
	CallSearchTeachers();
});
$('.InputTeacherName').keydown(function(e){
	if(e.keyCode==13){
		$('.InputTeacherName').focusout('focusout');
		$(this).blur();
	}
});

$('.SelectFaculty').focusout(function(){
	$('.SelectFaculty').trigger('change');
});
$('.SelectDepartment').focusout(function(){
	$('.SelectDepartment').trigger('change');
});

// Конец поиска преподавателей

// Отсоединить преподавателя
$('.TeachersList').on('click', 'button.Action_UnbindTeacher', function(){
	var thisObj = $(this);
	$(this).attr("disabled", true);
	var ID = $(this).parent().attr('id');
	$.post(
		URLdir + 'handler/map/UnbindTeacher',
		{
			'BindingTeacher': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				EventInspector_ShowMsg('Преподаватель отсоединен', 'success');
				thisObj
					.parent()
					.remove();
			}
			else {
				EventInspector_ShowMsg('Ошибка при отсоединение преподавателя', 'error');
				thisObj.removeAttr('disabled');
			}
		}
	);
});

// Присоединить преподавателя
$('.TeachersList').on('click', 'button.Action_BindTeacher', function(){
	var thisObj = $(this);
	$(this).attr("disabled", true);
	var ID = $(this).parent().attr('id');
	var Name = $(this).siblings('.Name').text();
	$.post(
		URLdir + 'handler/map/BindTeacher',
		{
			'BindingTeacher': ID,
			'DisciplineID': DisciplineID
		},
		function(data){
			data = $.parseJSON(data);
			if(data.success === true) {
				$('.BindTeachersList').append(AddTeacher(ID, Name, 'Unbind'));
				EventInspector_ShowMsg('Преподаватель прикреплен', 'success');
				thisObj
					.parent()
					.remove();
			}
			else {
				EventInspector_ShowMsg('Ошибка при прикрепление преподавателя', 'error');
				thisObj.removeAttr('disabled');
			}
		}
	);
});

});